{***********************************************************}
{* 'XOR Implementation 2' unit for LogicGates2 application *}
{***********************************************************}

unit xor_impl2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Grids;

type
  {********}
  { TfXOR2 }
  {********}
  TfXOR2 = class(TForm)
    Label1,  Label2,  Label3,  Label4,  Label5: TLabel;
    Shape1,  Shape2,  Shape3,  Shape4,  Shape5: TShape;
    Shape6,  Shape7,  Shape8,  Shape9,  Shape10: TShape;
    Shape11, Shape12, Shape13, Shape14, Shape15: TShape;
    Shape16, Shape20, Shape21, Shape23, Shape24: TShape;
    Shape25, Shape26, Shape27, Shape28: TShape;
    Image3,  Image4,  Image5: TImage;
    imSw1: TImage;
    shSw1a: TShape;
    shSw1b: TShape;
    imSw2: TImage;
    shSw2a: TShape;
    shSw2b: TShape;
    shA: TShape;
    shB: TShape;
    shOut1: TShape;
    shOut2: TShape;
    shOut: TShape;
    Memo1: TMemo;
    StaticText1: TStaticText;
    StringGrid1: TStringGrid;
    btClose: TButton;
    procedure FormCreate(Sender: TObject);
    procedure imSw1Click(Sender: TObject);
    procedure imSw2Click(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
  private
    bSw1, bSw2: Boolean;
  end;

var
  fXOR2: TfXOR2;

implementation

{$R *.lfm}

{ Do the logical circuit simulation }

procedure DoCircuit(A, B: Boolean);

var
  Out1, Out2, Out0: Boolean;

begin
  // Just do Boolean algebra (all integrated in Pascal)
  Out1 := A or B;
  Out2 := not (A and B);
  Out0 := Out1 and Out2;
  // Change LED status: "on" = solid color; "off" = "diagonal crossed"
  if A then
    fXOR2.shA.Brush.Style := bsSolid
  else
    fXOR2.shA.Brush.Style := bsDiagCross;
  if B then
    fXOR2.shB.Brush.Style := bsSolid
  else
    fXOR2.shB.Brush.Style := bsDiagCross;
  if Out1 then
    fXOR2.shOut1.Brush.Style := bsSolid
  else
    fXOR2.shOut1.Brush.Style := bsDiagCross;
  if Out2 then
    fXOR2.shOut2.Brush.Style := bsSolid
  else
    fXOR2.shOut2.Brush.Style := bsDiagCross;
  if Out0 then
    fXOR2.shOut.Brush.Style := bsSolid
  else
    fXOR2.shOut.Brush.Style := bsDiagCross;
end;

{********}
{ TfXOR2 }
{********}

{ Application start: Do circuit simulation with both inputs low }

procedure TfXOR2.FormCreate(Sender: TObject);

begin
  bSw1 := False; bSw2 := False;
  DoCircuit(bSw1, bSw2);
end;

{ Switch 1 area clicked: Move switch 1 shapes; change input A status and update circuit simulation }

procedure TfXOR2.imSw1Click(Sender: TObject);

begin
  if bSw1 then begin
    shSw1a.Top := 46; shSw1b.Top := 56;
    bSw1 := False;
  end
  else begin
    shSw1a.Top := 51; shSw1b.Top := 61;
    bSw1 := True;
  end;
  DoCircuit(bSw1, bSw2);
end;

{ Switch 2 area clicked: Move switch 2 shapes; change input B status and update circuit simulation }

procedure TfXOR2.imSw2Click(Sender: TObject);

begin
  if bSw2 then begin
    shSw2a.Top := 198; shSw2b.Top := 208;
    bSw2 := False;
  end
  else begin
    shSw2a.Top := 204; shSw2b.Top := 214;
    bSw2 := True;
  end;
  DoCircuit(bSw1, bSw2);
end;

{ Button "Close": Close the form }

procedure TfXOR2.btCloseClick(Sender: TObject);

begin
  Close;
end;

end.

